import 'dart:convert';
import 'dart:io';
import '../lib/craftsman.dart' show Utils;

main(List<String> args) {
  // if (args.length <= 0) {
  //   Utils.log('You should insert a descriptor name', color: 'red');
  //   return;
  // }

  // //get descriptor name
  // final name = args[0];

  //handle command
  _descriptor();
}

void _descriptor() {
  // VERSION
  Utils.log("Write the database version (default = 1)", color: 'green');
  var line = stdin.readLineSync(encoding: Encoding.getByName('utf-8'));
  int dbVersion = int.tryParse(line);
  if (dbVersion == null) {
    Utils.log("Your input was not a valid version, version will be 1", color: 'yellow');
    dbVersion = 1;
  }
  Utils.log("DB VERSION = $dbVersion", color: 'blue');
  
  // CHECK FILE EXISTENCE
  Utils.log("Building descriptor '$dbVersion.json'", color: 'green');
  if (File("craftsman/descriptors/$dbVersion.json").existsSync()) {
    Utils.log("Descriptor with name '$dbVersion.json' already exists, do you want to overwrite? (y = yes | n = no)", color: 'yellow');
    var line = stdin.readLineSync(encoding: Encoding.getByName('utf-8'));
    if(line.trim().toLowerCase() != 'y' && line.trim().toLowerCase() != 'yes') {
      Utils.log("Exiting Descriptor build, see ya!", color: 'red');
      return;
    }
  }

  // CREATING FILE
  new File("craftsman/descriptors/$dbVersion.json").create(recursive: true).then((file) {
    file.writeAsStringSync("""{
  "db": {
    "version": $dbVersion,
    "migrations": [
      {
        "create_table": {
          "name": "TABLE_NAME",
          "columns": [
            {
              "name": "id",
              "type": "integer",
              "index": "primary"
            },
            "timestamps"
          ]
        }
      }
    ]
  },
  "orm": {
    "create_models": [
      {
        "entity": "MODEL_NAME",
        "from_migration_table": "TABLE_NAME"
      }
    ]
  }
}""");
  });

  Utils.log("Created new File in 'craftsman/descriptors' folder!", color: 'green');
}
